<?php

namespace App\Tests;

use ApiPlatform\Symfony\Bundle\Test\ApiTestCase;
use App\Entity\Region;
use Hautelook\AliceBundle\PhpUnit\RefreshDatabaseTrait;

class RegionTest extends ApiTestCase
{
    // This trait provided by AliceBundle will take care of refreshing the database content to a known state before each test
    // use RefreshDatabaseTrait;



    public function testCreateRegion(): void
    {
        static::createClient()->request('POST', '/api/regions', ['json' => [
            "slug" => "region1",
            "code" => 01,
            "name" => "region1",
            "departments" => []
        ]]);

        $this->assertResponseStatusCodeSame(201);
        $this->assertResponseHeaderSame('content-type', 'application/ld+json; charset=utf-8');
        $this->assertJsonContains([
            "@context" => "/api/contexts/Region",
            '@type' => 'Region',
            "slug" => "region1",
            "code" => 01,
            "name" => "region1",
            "departments" => []
        ]);

        $this->assertMatchesResourceItemJsonSchema(Region::class);
    }

    // public function testReadRegion(): void
    // {
    //     // The client implements Symfony HttpClient's `HttpClientInterface`, and the response `ResponseInterface`
    //     $response = static::createClient()->request('GET', '/api/regions');

    //     $this->assertResponseIsSuccessful();
    //     // Asserts that the returned content type is JSON-LD (the default)
    //     $this->assertResponseHeaderSame('content-type', 'application/ld+json; charset=utf-8');

    //     // Asserts that the returned JSON is a superset of this one
    //     $this->assertJsonContains([
    //         'hydra:totalItems' => 1,
    //         'id' => 1,
    //         'slug' => 'region1',
    //         'code' => 1,
    //         'name' => 'region1',
    //         'departments' => 
    //         array (
    //         ),
    //     ]);

    //     // Because test fixtures are automatically loaded between each test, you can assert on them
    //     // $this->assertCount(30, $response->toArray()['hydra:member']);

    //     // Asserts that the returned JSON is validated by the JSON Schema generated for this resource by API Platform
    //     // This generated JSON Schema is also used in the OpenAPI spec!
    //     $this->assertMatchesResourceCollectionJsonSchema(Region::class);
    // }


    // public function testUpdateRegion(): void
    // {
    //     $client = static::createClient();
    //     // findIriBy allows to retrieve the IRI of an item by searching for some of its properties.
    //     // ISBN 9786644879585 has been generated by Alice when loading test fixtures.
    //     // Because Alice use a seeded pseudo-random number generator, we're sure that this ISBN will always be generated.
    //     $iri = $this->findIriBy(Region::class, ['name' => 'region1']);

    //     $client->request('PUT', $iri, ['json' => [
    //         'name' => 'updated name',
    //     ]]);

    //     $this->assertResponseIsSuccessful();
    //     $this->assertJsonContains([
    //         '@id' => $iri,
    //         'name' => 'updated name',
    //     ]);
    // }


    // public function testDeleteRegion(): void
    // {
    //     $client = static::createClient();
    //     $iri = $this->findIriBy(Region::class, ['name' => 'updated name']);

    //     $client->request('DELETE', $iri);

    //     $this->assertResponseStatusCodeSame(204);
    //     $this->assertNull(
    //         // Through the container, you can access all your services from the tests, including the ORM, the mailer, remote API clients...
    //         static::getContainer()->get('doctrine')->getRepository(Region::class)->findOneBy(['name' => 'updated name'])
    //     );
    // }
}
